import '../common/name.dart';
import '../common/named_api_resource.dart';
import '../common/named_api_resource_list.dart';
import '../../network/rest.dart';

///Versions of the games, e.g., Red, Blue or Yellow.
class Version {
  int id;
  String name;
  List<Name> names;
  NamedApiResource versionGroup;

  Version.fromJson(Map<String, dynamic> json)
      : id = json['id'],
        name = json['name'],
        names = Name.fromList(json['names']),
        versionGroup = NamedApiResource.fromJson(json['version_group']);

  static Future<Version> get(String query) async =>
      Version.fromJson(await RestConnection.get<Version>(query));

  static Future<NamedApiResourceList> find(
          [int limit = 0, int skip = 0]) async =>
      NamedApiResourceList.fromJson(
          await RestConnection.find<Version>(limit, skip));

  @override
  toString() =>
      '$runtimeType {id: $id, name: $name, names: $names, versionGroup: $versionGroup}';
}
